% 1)
load data
load geneNames
X = data.exprs;
y = data.classes;
% '2' ... AML
% '1' ... ALL

% learning the tree on complete data
tree = ClassificationTree.fit(X,y, 'PredictorNames', geneNames); 
%%
% 2)

tree.view('mode','graph')
% and its TRAINING accuracy
mean(y==tree.predict(X))

%%
% 3)  Estimation of real accuracy of the tree by the means of crossvalidation
cv = cvpartition(length(y),'kfold',10);

PA = []; % predictive accuracy
for i = 1:10
    trI = cv.training(i);
    tstI = cv.test(i);
    
    % tree learning
    % ...
    
    % tree testing
    pa = % accuracy in THIS fold
    
    PA = [PA; pa];
end
mean(PA)

%%
% % % % % % % % % % % % % % % % % % %
% Analyzing the data in terms of PCA

% 1)  
% learning principal components of the data
V = pca(X);

% 2) - 3)
PAs = []; % predictive accuracies of trees based on subsequent decompositions
for K = [5 10 20 50]

    % transforming the data into top K components
    Z = X*V(1:K,:)';
    
    % Here learn a tree on Z
    % ...

    % show it and enumearate its TRAINING accuracy
    % ...
    PA = % training accuracy of the tree learned on top K data components
    
    PAs = [PAs; PA];

end
%%
% 4) 
% For the optimal K_opt, heuristically chosen according to the criteria
% above...

K_opt = % optimal number of copmponents

% Make an optimal data transformation
Z_opt = X*V(1:K_opt,:)';

% And estimate the real accuracy of emerging tree-model by the means of 
% crossvalidation

PA = [];
for i = 1:10
    trI = cv.training(i);
    tstI = cv.test(i);
           
    % learning principal components of TRAINING data
    % ...
    
    % transformation of TRAINING data into first K_opt of the principal components
    % ...
    
    % learning a tree on the transformed data
    % ...
    
    % transformation of TESTING data
    % ...
    
    % testing the tree on the transformed data
    % ...
    pa = % accuracy in THIS fold
    
    PA = [PA; pa];
end
mean(PA)
%%
% % % % % % % % % % % % % % 
% Interpreting the results

% indices of the top components in your tree
componentIndices = [% indices of the top components in your tree
		      ]
compGenes = {}; % genes overrepresented in the top components in your tree
for c = componentIndices
    compGenes = {compGenes, mineGenes(V(c,:), geneNames)};
end

